$regfile = "m32def.dat"
$lib "mcsbyte.lbx" , "i2c_twi.lbx"
$hwstack = 100
$swstack = 50
$framesize = 30
$crystal = 8000000
$baud = 9600
Config Timer1 = Timer , Prescale = 64
Config Scl = Portc.0 : Config Sda = Portc.1 : Config Twi = 100000       'Pin 22 SCL , pin 23 SDA
Config Lcd = 16 * 2 : Config 1wire = Portd.2                '1-Wire Port , Pin 21
Config Clock = User : Config Date = Dmy , Separator = /
Dim Weekday As Byte , Secreaction As Bit , Blcount As Byte , Blindex As Bit , 1wr(8) As Byte
Dim Secondtic As Byte , Key1(20) As Eram Byte , Key2(20) As Eram Byte , Key3(20) As Eram Byte , Key4(20) As Eram Byte
Dim X As Byte , Key6(20) As Eram Byte , Bannercount As Byte , Bannerchange As Bit , Serialin As Byte
Dim Key5(20) As Eram Byte , Timestr As String * 5 , Div As String * 1 , Keybuf(6) As Byte , Keybuf1(6) As Byte
Dim Daystr As String * 8 , Accesscount As Byte , Accessvalue As Eram Byte , Blvalue As Eram Byte
Dim Accesson As Bit , Locked As Eram Byte , Password As Eram String * 10 , Pass As String * 10
Dim Owner1 As String * 15 , Owner(20) As Eram String * 15 , Mkeyindex As Eram Byte , Wdstr As String * 10
Dim Pass1 As String * 10 , Passactive As Eram Byte , Y As Byte , Mkey4 As Eram Byte
Dim Mkey1 As Eram Byte , Mkey2 As Eram Byte , Mkey3 As Eram Byte , Mkey5 As Eram Byte , Mkey6 As Eram Byte
Const Ds1307w = &HD0                                        ' Addresses of Ds1307 clock
Const Ds1307r = &HD1
Ddrb = &B11111110 : Portb = &B11111101                      'Port initialization
Ddrc = &B00001111 : Portc = &B11110011
If Mkeyindex = 255 Then Mkeyindex = 0
If Locked = 255 Then Locked = 0
If Passactive = 255 Then Password = "123456"
If Accessvalue = 255 Then Accessvalue = 8
If Blvalue = 255 Then Blvalue = 40
Secondtic = 0 : Secreaction = 0 : X = 0 : 1wr(8) = 0
Bannercount = 0 : Bannerchange = 0
Exitbutton Alias Pinb.0 : Closel Alias Portb.1
Bklight Alias Portc.2 : Spk Alias Portc.3
Prog Alias Pinc.4 : Lock Alias Pinc.5
Cursor Off : Cls
I2cinit                                                     'I2C BUS initialization
I2cstart                                                    'Write config (DS1307)
I2cwbyte Ds1307w
I2cwbyte &H07
I2cwbyte 0
I2cstop
If Locked = 1 Then
Locate 1 , 6 : Lcd "MASTER" : Locate 2 , 7 : Lcd "LOCK"
End If
On Timer1 Multiinterrupt
Enable Timer1 : Enable Interrupts
'---------------------------------------------------------------------------------------------------------------------
Do                                                          'Main loop
Serialin = Inkey()
If Serialin = "m" Or Serialin = "M" And Locked = 0 Then Gosub Serialmenu
Debounce Exitbutton , 0 , Exitdoor , Sub
If Accesson = 1 Then Goto No1w
Retry:
1wreset                                                     'reset the device
If Err = 1 Then Goto No1w                                   'No device jump
1wwrite &H33                                                'read ROM command
1wr(1) = 1wread(8)                                          'read 8 bytes
If 1wr(8) = Crc8(1wr(1) , 7) Then Gosub Id Else Goto Retry  'calculate CRC ,identification subroutine
If 1wr(2) = 0 And 1wr(3) = 0 And 1wr(4) = 0 And 1wr(5) = 0 And 1wr(6) = 0 And 1wr(7) = 0 Then Goto Retry
No1w:
If Locked = 1 Then Goto Exitbanner
If Secreaction = 0 Then Div = ":" Else Div = " "
Timestr = Format(str(_hour) , "00") + Div + Format(str(_min) , "00")       'time string
Daystr = Format(str(_day) , "00") + "/" + Format(str(_month) , "00") + "/" + Format(str(_year) , "00")       'date string
Locate 1 , 2 : Lcd Daystr : Locate 1 , 11 : Lcd Timestr
If Accesson = 1 Then
Set Closel : Locate 2 , 1 : Lcd Spc(1) ; "ACCESS GRANDED" ; Spc(1)
Else
If Bannerchange = 0 Then
Locate 2 , 1 : Lcd Spc(1) ; "TOUCH YOUR KEY" ; Spc(1)
Else
Locate 2 , 1 : Lcd "i-BUTTON ACCESS"
End If
End If
Exitbanner:
Loop
'---------------------------------------------------------------------------------------------------------------------
Exitdoor:
Gosub Substart : Accesson = 1 : Set Closel : Cls
Locate 1 , 5 : Lcd "EXITING"
Do
Loop Until Accesson = 0
Blindex = 0 : Blcount = 0 : Cls
Return
'---------------------------------------------------------------------------------------------------------------------
Serialmenu:
Gosub Substart : Cls
Locate 1 , 6 : Lcd "SERIAL" : Locate 2 , 3 : Lcd "COMMUNICATION"
Print "{027}[2J{027}[1;19H**********Password required !!!**********"
Pass = Password : Echo Off
Input "{027}[3;32HEnter password" , Pass1
If Pass <> Pass1 Then
Print "{027}[3;32H{027}[K{027}[5;30HWrong password!!" : Sound Spk , 1000 , 500 : Goto Exitserialmenu
Else
Print "{027}[3;32H{027}[K{027}[5;30HPassword accepted!!" : Wait 2 : Print "{027}[2J"
End If
Echo On : Gosub Menuhead
Do
Serialin = Inkey()
If Serialin = "1" Then Gosub Serialsettime
If Serialin = "2" Then Gosub Managekeysser
If Serialin = "3" Then Gosub Chpass
If Serialin = "4" Then Gosub Chpassword
If Serialin = "5" Then Gosub Masterset
If Serialin = Chr(27) Then Goto Exitserialmenu
Loop
Exitserialmenu:
Print "{027}[2J{027}[1;1H"
Serialin = 0 : Blindex = 0 : Sound Spk , 100 , 150 : Cls
Return
'---------------------------------------------------------------------------------------------------------------------
Masterreg:
Gosub Substart : Cls
Loopback2:
Locate 1 , 1 : Lcd Spc(1) ; "TOUCH YOUR KEY" ; Spc(1) : Locate 2 , 1 : Lcd Spc(1) ; "[prog] to exit" : Bitwait Prog , Set : Wait 1
Retry4:
If Prog = 0 Then
Sound Spk , 100 , 150 : Goto Conexit1
End If
1wreset                                                     'reset the device
If Err = 1 Then Goto Retry4                                 'No device jump
1wwrite &H33                                                'read ROM command
1wr(1) = 1wread(8)                                          'read 8 bytes
If 1wr(8) <> Crc8(1wr(1) , 7) Then Goto Retry4              'calculate CRC
If 1wr(2) = 0 And 1wr(3) = 0 And 1wr(4) = 0 And 1wr(5) = 0 And 1wr(6) = 0 And 1wr(7) = 0 Then Goto Retry4
Keybuf1(1) = 1wr(7) : Keybuf1(2) = 1wr(6) : Keybuf1(3) = 1wr(5) : Keybuf1(4) = 1wr(4) : Keybuf1(5) = 1wr(3) : Keybuf1(6) = 1wr(2)
If Mkey1 = 1wr(2) And Mkey2 = 1wr(3) And Mkey3 = 1wr(4) And Mkey4 = 1wr(5) And Mkey5 = 1wr(6) And Mkey6 = 1wr(7)then
Locate 2 , 1 : Lcd Spc(3) ; "MASTER KEY" ; Spc(3) : Sound Spk , 1000 , 500 : Wait 2 : Cls : Goto Loopback2
End If
For X = 1 To 20
If Key1(x) = Keybuf1(6) And Key2(x) = Keybuf1(5) And Key3(x) = Keybuf1(4) And Key4(x) = Keybuf1(3) And Key5(x) = Keybuf1(2) And Key6(x) = Keybuf1(1) Then
Sound Spk , 1000 , 500 : Locate 2 , 1 : Lcd "Key is in memory" : Wait 2 : Cls : Goto Loopback2
End If
Next X
For X = 1 To 20
Keybuf(1) = Key6(x) : Keybuf(2) = Key5(x) : Keybuf(3) = Key4(x) : Keybuf(4) = Key3(x) : Keybuf(5) = Key2(x) : Keybuf(6) = Key1(x)
If Keybuf(1) = 255 And Keybuf(2) = 255 And Keybuf(3) = 255 And Keybuf(4) = 255 And Keybuf(5) = 255 And Keybuf(6) = 255 Then
Key1(x) = Keybuf1(6) : Key2(x) = Keybuf1(5) : Key3(x) = Keybuf1(4) : Key4(x) = Keybuf1(3) : Key5(x) = Keybuf1(2) : Key6(x) = Keybuf1(1)
Owner(x) = "" : Sound Spk , 100 , 150 : Locate 2 , 1 : Lcd Spc(1) ; "Key saved!!!" ; Spc(3) : Wait 2 : Goto Conexit1
End If
Next X
Conexit1:
Gosub Light : Cls
Return
'---------------------------------------------------------------------------------------------------------------------
Masterset:
Loopback3:
Print "{027}[2J{027}[1;23H**********Master key set**********{027}[3;21HTouch the master key or [Esc] to exit"
Retry3:
Serialin = Inkey() : If Serialin = Chr(27) Then Goto Exitmasterset
1wreset                                                     'reset the device
If Err = 1 Then Goto Retry3                                 'No device jump
1wwrite &H33                                                'read ROM command
1wr(1) = 1wread(8)                                          'read 8 bytes
If 1wr(8) <> Crc8(1wr(1) , 7) Then Goto Retry3              'calculate CRC
If 1wr(2) = 0 And 1wr(3) = 0 And 1wr(4) = 0 And 1wr(5) = 0 And 1wr(6) = 0 And 1wr(7) = 0 Then Goto Retry3
Keybuf1(1) = 1wr(7) : Keybuf1(2) = 1wr(6) : Keybuf1(3) = 1wr(5) : Keybuf1(4) = 1wr(4) : Keybuf1(5) = 1wr(3) : Keybuf1(6) = 1wr(2)
For X = 1 To 20
If Key1(x) = Keybuf1(6) And Key2(x) = Keybuf1(5) And Key3(x) = Keybuf1(4) And Key4(x) = Keybuf1(3) And Key5(x) = Keybuf1(2) And Key6(x) = Keybuf1(1) Then
Sound Spk , 1000 , 500 : Print "{027}[3;1H{027}[K{027}[3;14HThe key is in memory. You can't use it as master key" : Wait 4 : Goto Loopback3
End If
Next X
Sound Spk , 100 , 150 : Print "{027}[3;1H{027}[K{027}[3;30HKey code accepted!!"
If Mkey1 = 1wr(2) And Mkey2 = 1wr(3) And Mkey3 = 1wr(4) And Mkey4 = 1wr(5) And Mkey5 = 1wr(6) And Mkey6 = 1wr(7) Then
Print "{027}[5;10HOld master key. press [1] to delete or press [Esc] to exit."
Do
Serialin = Inkey() : If Serialin = "1" Then Goto Masterdelete : If Serialin = Chr(27) Then Goto Exitmasterset
Loop
Else
Print "{027}[5;11HNew master key. press [1] to save or press [Esc] to exit."
End If
Do
Serialin = Inkey() : If Serialin = "1" Then Goto Mastersave : If Serialin = Chr(27) Then Goto Exitmasterset
Loop
Mastersave:
Mkey1 = 1wr(2) : Mkey2 = 1wr(3) : Mkey3 = 1wr(4) : Mkey4 = 1wr(5) : Mkey5 = 1wr(6) : Mkey6 = 1wr(7) : Mkeyindex = 1
Goto Exitmasterset
Masterdelete:
If Mkey1 = 1wr(2) And Mkey2 = 1wr(3) And Mkey3 = 1wr(4) And Mkey4 = 1wr(5) And Mkey5 = 1wr(6) And Mkey6 = 1wr(7) Then
Mkey1 = 255 : Mkey2 = 255 : Mkey3 = 255 : Mkey4 = 255 : Mkey5 = 255 : Mkey6 = 255 : Mkeyindex = 0
End If
Exitmasterset:
Print "{027}[2J" : Serialin = 0 : Gosub Menuhead
Return
'---------------------------------------------------------------------------------------------------------------------
Chpassword:
Print "{027}[2J{027}[1;23H**********Change password**********"
Confirm:
Input "{027}[3;30HEnter new password:" , Pass
Input "{027}[3;30H{027}[K{027}[3;31HConfirm password:" , Pass1
If Pass <> Pass1 Then
Print "{027}[3;30H{027}[K{027}[3;31Hpassword mismatch" : Sound Spk , 1000 , 500 : Goto Confirm
End If
Passactive = 1 : Password = Pass : Print "{027}[3;30H{027}[K{027}[6;31HPssword changed!!"
Wait 2 : Print "{027}[2J" : Gosub Menuhead
Return
'---------------------------------------------------------------------------------------------------------------------
Menuhead:
Wdstr = Lookupstr(weekday , Weekdays) : Wdstr = Left(wdstr , 3)
Print "{027}[1;10H**********Menu**********{027}[3;11H[1] Set time and date{027}[4;11H[2] Manage keys"
Print "{027}[5;11H[3] Change delay time{027}[6;11H[4] Change password{027}[7;11H[5] Set master key{027}[8;11H[Esc] Exit"
Timestr = Format(str(_hour) , "00") + ":" + Format(str(_min) , "00")
Print "{027}[1;45H**********Status**********{027}[3;47HSystem time:" ; Spc(1) ; Timestr ; "{027}[4;47HSystem date:" ; Spc(1) ; Wdstr ; Spc(1) ; Daystr
X = Blvalue : X = X / 4 : Print "{027}[5;47HLCD backlight delay time:" ; Spc(1) ; X ; "sec"
X = Accessvalue : X = X / 4 : Print "{027}[6;47HAccess delay time:" ; Spc(1) ; X ; "sec" : X = 0 : Y = 0
For X = 1 To 20
Keybuf(1) = Key6(x) : Keybuf(2) = Key5(x) : Keybuf(3) = Key4(x) : Keybuf(4) = Key3(x) : Keybuf(5) = Key2(x) : Keybuf(6) = Key1(x)
If Keybuf(1) <> 255 And Keybuf(2) <> 255 And Keybuf(3) <> 255 And Keybuf(4) <> 255 And Keybuf(5) <> 255 And Keybuf(6) <> 255 Then Incr Y
Next X
Print "{027}[7;47HKeys in memory:" ; Spc(1) ; Y : Y = 20 -y : Print "{027}[8;47HRemaining keys to store:" ; Spc(1) ; Y : Y = 0
If Mkeyindex = 0 Then Print "{027}[9;47HMaster key: not set" Else Print "{027}[9;47HMaster key: set"
Print "{027}[24;2H(c)2006 Dselec (http://dimelec.web1000.com)";
Return
'---------------------------------------------------------------------------------------------------------------------
Managekeysser:
Loopback:
Print "{027}[2J{027}[1;24H***********Manage keys**********{027}[3;30HKey codes in memory{027}[4;29H*********************"
For X = 1 To 20
Owner1 = Owner(x)
Keybuf(1) = Key6(x) : Keybuf(2) = Key5(x) : Keybuf(3) = Key4(x) : Keybuf(4) = Key3(x) : Keybuf(5) = Key2(x) : Keybuf(6) = Key1(x)
If Keybuf(1) = 255 And Keybuf(2) = 255 And Keybuf(3) = 255 And Keybuf(4) = 255 And Keybuf(5) = 255 And Keybuf(6) = 255 Then Goto Exitprint
Y = X + 4
Print "{027}[" ; Y ; ";31H" ; "No" ; X ; ":" ; Hex(keybuf(1)) ; Hex(keybuf(2)) ; Hex(keybuf(3)) ; Hex(keybuf(4)) ; Hex(keybuf(5)) ; Hex(keybuf(6)) ; " " ; Owner1
Exitprint:
If Y = 0 Then Y = 4
Next X
Y = Y + 1 : Print "{027}[" ; Y ; ";29H*********************" : Y = Y + 2
Print "{027}[" ; Y ; ";2HTouch the key or [m] to enter 6 digit HEX key code manually or [Esc] to exit"
Retry2:
Serialin = Inkey()
If Serialin = "m" Or Serialin = "M" Then Goto Manualenter
If Serialin = Chr(27) Then Goto Exitmanage
1wreset                                                     'reset the device
If Err = 1 Then Goto Retry2                                 'No device jump
1wwrite &H33                                                'read ROM command
1wr(1) = 1wread(8)                                          'read 8 bytes
If 1wr(8) <> Crc8(1wr(1) , 7) Then Goto Retry2              'calculate CRC if ok continue
If 1wr(2) = 0 And 1wr(3) = 0 And 1wr(4) = 0 And 1wr(5) = 0 And 1wr(6) = 0 And 1wr(7) = 0 Then Goto Retry2
Sound Spk , 100 , 150
Keybuf1(1) = 1wr(7) : Keybuf1(2) = 1wr(6) : Keybuf1(3) = 1wr(5) : Keybuf1(4) = 1wr(4) : Keybuf1(5) = 1wr(3) : Keybuf1(6) = 1wr(2)
Goto Selectact
Manualenter:
Print "{027}[2;1H{027}[J"
For X = 1 To 6
Inputhex "{027}[3;31HEnter digit No" ; X ; ":" , Keybuf1(x) : Print "{027}[3;31H{027}[K"
Next X
Print "{027}[3;31H{027}[K{027}[3;29HKey code:" ; Hex(keybuf1(1)) ; Hex(keybuf1(2)) ; Hex(keybuf1(3)) ; Hex(keybuf1(4)) ; Hex(keybuf1(5)) ; Hex(keybuf1(6))
Print "{027}[5;24HIs this correct? (y) Yes (n) No"
Do
Serialin = Inkey()
If Serialin = "y" Or Serialin = "Y" Then Goto Selectact
If Serialin = "n" Or Serialin = "N" Then Goto Manualenter
Loop
Selectact:
If Mkey1 = Keybuf1(6) And Mkey2 = Keybuf1(5) And Mkey3 = Keybuf1(4) And Mkey4 = Keybuf1(3) And Mkey5 = Keybuf1(2) And Mkey6 = Keybuf1(1) Then
Print "{027}[2;1H{027}[J{027}[3;18HThis is the master key!! You can't edit that" : Sound Spk , 1000 , 500 : Goto Conexit
End If
Print "{027}[2;1H{027}[J{027}[3;29HKey code:" ; Hex(keybuf1(1)) ; Hex(keybuf1(2)) ; Hex(keybuf1(3)) ; Hex(keybuf1(4)) ; Hex(keybuf1(5)) ; Hex(keybuf1(6))
For X = 1 To 20
Keybuf(1) = Key6(x) : Keybuf(2) = Key5(x) : Keybuf(3) = Key4(x) : Keybuf(4) = Key3(x) : Keybuf(5) = Key2(x) : Keybuf(6) = Key1(x)
If Keybuf1(1) = Keybuf(1) And Keybuf1(2) = Keybuf(2) And Keybuf1(3) = Keybuf(3) And Keybuf1(4) = Keybuf(4) And Keybuf1(5) = Keybuf(5) And Keybuf1(6) = Keybuf(6) Then
Print "{027}[5;2HKey is in memory. Press [d] to delete or [c] to change name or [Esc] to exit"
Do
Serialin = Inkey()
If Serialin = "c" Or Serialin = "C" Then Goto Changename
If Serialin = "d" Or Serialin = "D" Then Goto Deletekey1
If Serialin = Chr(27) Then
Print "{027}[5;2H{027}[K" : Goto Conexit
End If
Loop
End If
Next X
Manual:                                                     'Write key to memory
Input "{027}[5;23HEnter owner's name:" , Owner1
For X = 1 To 20
Keybuf(1) = Key6(x) : Keybuf(2) = Key5(x) : Keybuf(3) = Key4(x) : Keybuf(4) = Key3(x) : Keybuf(5) = Key2(x) : Keybuf(6) = Key1(x)
If Keybuf(1) = 255 And Keybuf(2) = 255 And Keybuf(3) = 255 And Keybuf(4) = 255 And Keybuf(5) = 255 And Keybuf(6) = 255 Then
Key1(x) = Keybuf1(6) : Key2(x) = Keybuf1(5) : Key3(x) = Keybuf1(4) : Key4(x) = Keybuf1(3) : Key5(x) = Keybuf1(2) : Key6(x) = Keybuf1(1)
Owner(x) = Owner1 : Print "{027}[5;23H{027}[K{027}[5;34HKey saved!!" : Goto Conexit
End If
Next X
Changename:                                                 'Key name change
Input "{027}[5;2H{027}[K{027}[5;25HEnter new name:" , Owner1
For X = 1 To 20
Keybuf(1) = Key6(x) : Keybuf(2) = Key5(x) : Keybuf(3) = Key4(x) : Keybuf(4) = Key3(x) : Keybuf(5) = Key2(x) : Keybuf(6) = Key1(x)
If Keybuf1(1) = Keybuf(1) And Keybuf1(2) = Keybuf(2) And Keybuf1(3) = Keybuf(3) And Keybuf1(4) = Keybuf(4) And Keybuf1(5) = Keybuf(5) And Keybuf1(6) = Keybuf(6) Then
Owner(x) = Owner1 : Print "{027}[5;25H{027}[K{027}[5;32HNew name saved!!" : Goto Conexit
End If
Next X
Deletekey1:
For X = 1 To 20
Keybuf(1) = Key6(x) : Keybuf(2) = Key5(x) : Keybuf(3) = Key4(x) : Keybuf(4) = Key3(x) : Keybuf(5) = Key2(x) : Keybuf(6) = Key1(x)
If Keybuf1(1) = Keybuf(1) And Keybuf1(2) = Keybuf(2) And Keybuf1(3) = Keybuf(3) And Keybuf1(4) = Keybuf(4) And Keybuf1(5) = Keybuf(5) And Keybuf1(6) = Keybuf(6) Then
Key1(x) = 255 : Key2(x) = 255 : Key3(x) = 255 : Key4(x) = 255 : Key5(x) = 255 : Key6(x) = 255 : Owner(x) = ""
Print "{027}[5;2H{027}[K{027}[5;33Hkey deleted!!" : Goto Conexit
End If
Next X
Conexit:
Print "{027}[7;14HPress [e] to exit or [g] to go back to key managment"
Do
Serialin = Inkey()
If Serialin = "e" Or Serialin = "E" Then Goto Exitmanage
If Serialin = "g" Or Serialin = "G" Then Goto Loopback
Loop
Exitmanage:
Serialin = 0 : Print "{027}[2J" : Gosub Menuhead
Return
'---------------------------------------------------------------------------------------------------------------------
Chpass:
Loopback1:
Print "{027}[2J{027}[1;21H**********Manage delay time**********"
X = Accessvalue : X = X / 4 : Print "{027}[3;27HEntrance delay time:" ; X ; "sec"
X = Blvalue : X = X / 4 : Print "{027}[4;27HLCD backlight delay time:" ; X ; "sec"
Print "{027}[5;23H*************************************{027}[7;26H[1] set entrance delay time.{027}[8;26H[2] set LCD backlight delay time."
Print "{027}[9;26H[Esc] Exit."
Do
Serialin = Inkey()
If Serialin = "1" Then Goto Entdel
If Serialin = "2" Then Goto Lcddel
If Serialin = Chr(27) Then Goto Exitch
Loop
Entdel:
Input "{027}[2;1H{027}[J{027}[3;26HSet entrance time (1-10sec):" , X
If X > 10 Or X = 0 Then
Print "{027}[3;26H{027}[k{027}[3;27HTime between 1 and 10sec!!" : Goto Entdel
End If
X = X * 4 : Accessvalue = X : Goto Loopch
Lcddel:
Input "{027}[2;1H{027}[J{027}[3;28HSet LCD time (1-60sec):" , X
If X > 60 Or X = 0 Then
Print "{027}[3;26H{027}[k{027}[3;27HTime between 1 and 60sec!!" : Goto Lcddel
End If
X = X * 4 : Blvalue = X : Goto Loopch
Loopch:
Print "{027}[3;26H{027}[k{027}[3;10HPress [e] to exit or [g] to go back to delay time managment"
Do
Serialin = Inkey()
If Serialin = "e" Or Serialin = "E" Then Goto Exitch
If Serialin = "g" Or Serialin = "G" Then Goto Loopback1
Loop
Exitch:
Print "{027}[2J" : Serialin = 0 : Gosub Menuhead
Return
'---------------------------------------------------------------------------------------------------------------------
Serialsettime:
Print "{027}[2J{027}[1;21H**********Set time and date**********{027}[3;34H[1] Set time{027}[4;34H[2] Set date{027}[5;34H[Esc] Exit"
Do
Serialin = Inkey()
If Serialin = "1" Then Goto Settime
If Serialin = "2" Then Goto Setdate
If Serialin = Chr(27) Then Goto Exitserialtime
Loop
Settime:
Input "{027}[2;1H{027}[J{027}[3;30HEnter hour (0-23):" , _hour
If _hour > 23 Then
Print "{027}[3;10H{027}[K{027}[3;19HWrong value!! (acceptable values 0 to 23)" : Goto Settime
End If
Input "{027}[3;10H{027}[K{027}[3;29HEnter minutes (0-59):" , _min
If _min > 59 Then
Print "{027}[3;10H{027}[K{027}[3;19HWrong value!! (acceptable values 0 to 59)" : Goto Settime
End If
_sec = 0
_sec = Makebcd(_sec) : _min = Makebcd(_min) : _hour = Makebcd(_hour)
I2cstart                                                    ' Generate start code
I2cwbyte Ds1307w                                            ' send address
I2cwbyte 0                                                  ' starting address in 1307
I2cwbyte _sec                                               ' Send Data to Seconds
I2cwbyte _min                                               ' Minutes
I2cwbyte _hour                                              ' Hours
I2cstop
Print "{027}[2;1H{027}[J{027}[3;20HDo you want to set date? (y) yes (n) no"
Do
Serialin = Inkey()
If Serialin = "y" Or Serialin = "Y" Then Goto Setdate
If Serialin = "n" Or Serialin = "N" Then Goto Exitserialtime
Loop
Setdate:
Input "{027}[2;1H{027}[J{027}[3;30HEnter date (1-31):" , _day
If _day > 31 Or _day = 0 Then
Print "{027}[3;30H{027}[K{027}[3;20HWrong value!! (acceptable values 1 to 31)" : Goto Setdate
End If
Setmonth:
Input "{027}[3;30H{027}[K{027}[3;30HEnter month (1-12):" , _month
If _month > 12 Or _month = 0 Then
Print "{027}[3;30H{027}[K{027}[3;20HWrong value!! (acceptable values 1 to 12)" : Goto Setmonth
End If
Setyear:
Input "{027}[2;1H{027}[J{027}[3;30HEnter year (0-99):" , _year
If _year > 99 Then
Print "{027}[3;30H{027}[K{027}[3;20HWrong value!! (acceptable values 0 to 99)" : Goto Setyear
End If
Daystr = Format(str(_day) , "00") + "/" + Format(str(_month) , "00") + "/" + Format(str(_year) , "00")
Weekday = Dayofweek(daystr) : Weekday = Weekday + 1
_day = Makebcd(_day) : _month = Makebcd(_month) : _year = Makebcd(_year) : Weekday = Makebcd(weekday)
I2cstart                                                    ' Generate start code
I2cwbyte Ds1307w                                            ' send address
I2cwbyte 3                                                  ' starting address in 1307
I2cwbyte Weekday                                            ' Day of week
I2cwbyte _day                                               ' Day of month
I2cwbyte _month                                             ' Month
I2cwbyte _year                                              'Year
I2cstop
Exitserialtime:
Serialin = 0 : Print "{027}[2J" : Gosub Menuhead
Return
'---------------------------------------------------------------------------------------------------------------------
Substart:
Sound Spk , 100 , 150 : Blcount = 0 : Blindex = 1 : Set Bklight
Return
'---------------------------------------------------------------------------------------------------------------------
Light:
Sound Spk , 100 , 150 : Blcount = 0 : Blindex = 0 : Set Bklight
Return
'---------------------------------------------------------------------------------------------------------------------
Id:
Blcount = 0 : Blindex = 1 : Set Bklight : Stop Timer1
Wdstr = Lookupstr(weekday , Weekdays)
If Mkey1 = 1wr(2) And Mkey2 = 1wr(3) And Mkey3 = 1wr(4) And Mkey4 = 1wr(5) And Mkey5 = 1wr(6) And Mkey6 = 1wr(7) And Locked = 0 And Prog = 0 Then
Gosub Masterreg : Goto Exitid
End If
If Mkey1 = 1wr(2) And Mkey2 = 1wr(3) And Mkey3 = 1wr(4) And Mkey4 = 1wr(5) And Mkey5 = 1wr(6) And Mkey6 = 1wr(7) And Lock = 1 Then
If Locked = 1 Then Locked = 0
Accesson = 1 : Timestr = Format(str(_hour) , "00") + ":" + Format(str(_min) , "00")
Print Spc(16) ; Wdstr ; Spc(7) ; Daystr ; Spc(7) ; Timestr ; Spc(7) ; "administrator"
Sound Spk , 200 , 200 : Cls : Goto Exitid
End If
If Mkey1 = 1wr(2) And Mkey2 = 1wr(3) And Mkey3 = 1wr(4) And Mkey4 = 1wr(5) And Mkey5 = 1wr(6) And Mkey6 = 1wr(7) And Lock = 0 Then
Sound Spk , 200 , 200 : Cls : Locate 1 , 6 : Lcd "MASTER" : Locate 2 , 7 : Lcd "LOCK" : Locked = 1 : Wait 3 : Goto Exitid
End If
If Prog = 1 And Lock = 1 Then
If Locked = 1 Then
Sound Spk , 1000 , 500 : Wait 2 : Goto Exitid
End If
For X = 1 To 20
If Key1(x) = 1wr(2) And Key2(x) = 1wr(3) And Key3(x) = 1wr(4) And Key4(x) = 1wr(5) And Key5(x) = 1wr(6) And Key6(x) = 1wr(7) Then
Accesson = 1 : Timestr = Format(str(_hour) , "00") + ":" + Format(str(_min) , "00") : Owner1 = Owner(x)
Print Spc(16) ; Wdstr ; Spc(7) ; Daystr ; Spc(7) ; Timestr ; Spc(7) ; Owner1
Sound Spk , 200 , 200 : Goto Exitid
End If
Next X
Locate 2 , 1 : Lcd Spc(1) ; "ACCESS DENIED" ; Spc(2) : Sound Spk , 1000 , 500 : Wait 1
End If
Exitid:
Blindex = 0 : Start Timer1
Return
'---------------------------------------------------------------------------------------------------------------------
Multiinterrupt:
Timer1 = &H85EE                                             '250ms overflow
Incr Secondtic
Incr Bannercount
If Bannercount = 6 Then
Toggle Bannerchange : Bannercount = 0
End If
If Secondtic = 2 Then                                       '500ms count
I2cstart                                                    ' Generate start code
I2cwbyte Ds1307w                                            ' send address
I2cwbyte 0                                                  ' start address in 1307
I2cstart                                                    ' Generate start code
I2cwbyte Ds1307r                                            ' send address
I2crbyte _sec , Ack                                         'Seconds
I2crbyte _min , Ack                                         ' Minutes
I2crbyte _hour , Ack                                        ' Hours
I2crbyte Weekday , Ack                                      ' Day of Week
I2crbyte _day , Ack                                         ' Day of Month
I2crbyte _month , Ack                                       ' Month of Year
I2crbyte _year , Nack                                       ' Year
I2cstop
_sec = Makedec(_sec) : _min = Makedec(_min) : _hour = Makedec(_hour)
_day = Makedec(_day) : Weekday = Makedec(weekday) : _month = Makedec(_month) : _year = Makedec(_year)
Secondtic = 0 : Toggle Secreaction
End If
If Bklight = 1 And Blindex = 0 Then                         'backlight display delay
Incr Blcount
If Blcount = Blvalue Then
Reset Bklight : Blcount = 0
End If
End If
If Accesson = 1 And Closel = 1 Then                         'Entrance delay
Incr Accesscount
If Accesscount = Accessvalue Then
Accesson = 0 : Accesscount = 0 : Reset Closel
End If
End If
Return
'---------------------------------------------------------------------------------------------------------------------
Weekdays:
Data "" , "Monday" , "Tuesday" , "Wednesday" , "Thursday" , "Friday" , "Saturday" , "Sunday"

'---------------------------------------------------------------------------------------------------------------------